import os 
import glob
from flask import Flask, jsonify 


base_url = '/soupboat/the-parliament'

# to add the prefix "/soupboat/the-parliament to the routes
class PrefixMiddleware(object):
    def __init__(self, app, prefix=""):
        self.app = app 
        self.prefix = prefix
    
    def __call__(self, environ, start_response):
        
        if environ["PATH_INFO"].startswith(self.prefix):
            environ["PATH_INFO"] = environ["PATH_INFO"][len(self.prefix):]
            environ["SCRIPT_NAME"] = self.prefix
            return self.app(environ, start_response)
        else:
            start_response("404", [("Content-Type", "text/plain")])
            return ["This url does not belong to the app".encode()]
        
        
# create flask app
app = Flask(__name__) 

     
        
app.wsgi_app = PrefixMiddleware(app.wsgi_app, prefix=base_url)




# Routes

@app.route('/')
def utility_page():
    
    source_folder = os.scandir("./jingles/")
    
    dir_names = []
    parties = []
    
    for entry in source_folder:
        if not entry.name.startswith('.') and entry.is_dir():
            party = entry.name
            parties.append(party)
    
    parliament = {}
    for party in parties:
        print(f'Party: {party}')
        files = [os.path.basename(x) for x in glob.glob(f"./jingles/{party}/*.mp3")]
        
        print(f'Files: {files}')
        
        names = [x.replace('.mp3','').replace('-', ' ').replace('_', ' ') for x in files]
        
        print(f'Names: {names}')
        
        
        group = []
        for index, file in enumerate(files):
            sample = {'filename' : file,
                     'who': names[index]}
            group.append(sample)

    
        parliament[party] = group
    
    print(parliament)
    
        
            
#             parties.append(entry.name)
          

    
    
    
    
#     files = [os.path.basename(x) for x in glob.glob("./jingles/*.mp3")]
    
#     names = [x.replace('.mp3','').replace('-', ' ') for x in files]
#     samples = []
#     for index, file in enumerate(files):
#         sample = {'filename' : file,
#                  'who': names[index]}
#         samples.append(sample)
#     print(names)
#     print(samples)
    
#     data = {'base_url': 'https://hub.xpub.nl/soupboat/SI18/04/the-parliament/jingles/',
#                'files': samples}

    
    data = {'base_url': 'https://hub.xpub.nl/soupboat/SI18/04/the-parliament/jingles/',
               'parliament': parliament}
    
    response = jsonify(data)
    # to allow request from different origins to the API
    response.headers.add('Access-Control-Allow-Origin', '*')
    return response
    
    



app.run(port=3143)


